/*
	$Id: BrowserController.h,v 1.5 2001/03/30 07:49:45 stephane Exp $
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.


#import <Foundation/NSObject.h>
#import <AppKit/AppKit.h>
#import "ResultsRepository.h"
#ifdef MACOSX
#import <SenBrowserCell.h>
#else
#import <SenInterface/SenBrowserCell.h>
#endif
#import "DirectoryContentsFilterProvider.h"

@class NSMutableDictionary;
@class ResultsRepository;
@class NSString;
@class NSArray;
@class NSBrowserCell;

@interface BrowserController:NSObject
{
	id	browser;
		
	ResultsRepository* resultsRepository;
    CVLFile *rootFile;
	int		updateCount;
    SenBrowserCell *cellPrototypes[ECInvalidFile+1];
    DirectoryContentsFilterProvider *filterProvider;
    NSMutableArray *filters;

    NSSize requestedBrowserSize;
    id delegate;
}

+ (BrowserController*) browserForPath: (NSString*) aPath;
+ setImageDict:(NSArray *)dict;

- initForPath: (NSString*) pathString;

- (void)selectFiles:(NSSet *)someFiles;
- (void)select: sender;
- (void)doubleSelect: sender;

- (void)setDelegate:(id)aDelegate;
- (void)setFilterProvider:(id)aProvider;
- (NSSize) viewerWillResizetoSize: (NSSize) frameSize;

- view;
- (NSString*) rootPath;

-(NSArray *)relativeSelectedPaths;
-(NSArray *)selectedPaths;
-(BOOL)selectionIsOneDir;

- (void) reloadData;

@end

@interface NSObject (BrowserControllerDelegate)
- (void)viewerFrameSizeChanged:(id)sender;
@end

/*
	$Log: BrowserController.h,v $
	Revision 1.5  2001/03/30 07:49:45  stephane
	Needed to modiy #imports for MacOSX (surrounded by #ifdef MACOSX)
	
	Revision 1.4  2000/05/08 14:04:08  stephane
	Updated copyright notice
	
	Revision 1.3  1999/10/18 11:06:55  stephane
	Support for quickStatus and lazyLoading (not yet working); added contextual menu for browser
	
	Revision 1.2  1998/10/02 05:46:28  vincent
	services added, nibs adapted to DR2
	
	Revision 1.1.1.1  1998/05/07 11:26:59  ja
	Updated version, moved to a new repository
	
	Revision 1.12.2.13  1998/05/01 17:15:05  ja
	Now uses a class in place of dictionaries
	
	Revision 1.12.2.12  1998/03/03 14:47:41  vincent
	no apparent changes
	
	Revision 1.12.2.11  1998/02/13 15:40:29  ja
	Preference for column width in work area browsers

	Revision 1.12.2.10  1997/10/29 13:13:30  ja
	Fixed all nibs and size problems
	
	Revision 1.12.2.9  1997/09/04 11:00:15  ja
	Supports restore version, ongoing requests classes rewrite

	Revision 1.12.2.8  1997/08/20 14:32:39  ja
	Filters !

	Revision 1.12.2.7  1997/08/18 15:01:28  ja
	Tokenized status, grouped status in types

	Revision 1.12.2.6  1997/04/11 16:12:51  ja
	Display all files now, find out what are the local ones and display them in different colors, no more unjustified question marks. Now need to filter the displayed files with some kind of preference

// Revision 1.12.2.5  1997/04/02  16:16:48  ja
// Working again
//
// Revision 1.12.2.3  1997/04/02  13:39:15  ja
// Merged with head, removed conflicts (not compiled yet)
//
// Revision 1.12.2.2  1997/03/25  15:31:57  ja
// Compiles !
//
// Revision 1.12.2.1  1997/03/21  11:12:25  ja
// Prepare to merge
//
// Revision 1.13  1997/03/18  15:11:36  vincent
// changed window resizing behavior, cleaned code
//
// Revision 1.13  1997/03/18  15:11:36  vincent
// changed window resizing behavior, cleaned code
//
// Revision 1.12  1996/11/26  14:33:58  vincent
// Defaults changed. Improved display. Code cleaned
//
// Revision 1.11  1996/06/11  09:57:30  vincent
// added inspectors (status only)
//
// Revision 1.10  1996/05/13  14:16:58  vincent
// menus reorganized, mini support for modules added
//
// Revision 1.9  1996/05/13  10:22:53  ja
// CvsRequest added, lazy status done
//
// Revision 1.8  1996/04/12  11:13:11  ja
// Moved isLeaf to ResultRepository, added untested SenInvocation
//
// Revision 1.7  1996/04/02  09:17:36  ja
// Merged dirsRepository in resultsRepository
//
// Revision 1.6  1996/03/27  15:11:55  ja
// Separated the dirs repository
//
// Revision 1.5  1996/03/27  06:46:32  vincent
// added simple progress panel, update browser feature recovered
//
// Revision 1.4  1996/03/22  14:17:58  ja
// Separate staus cache
//
// Revision 1.3  1996/03/20  14:37:23  vincent
// added new class to support multiple browsers
//
*/
