/*
	$Id: CVLDelegate.h,v 1.6 2002/07/01 12:59:27 stephane Exp $
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.


#import <Foundation/Foundation.h>
#import <AppKit/NSNibDeclarations.h>

@class ResultsRepository;
@class NSString;
@class NSMutableString;
@class NSMutableArray;
@class NSMutableDictionary;
@class Request;
@class WorkAreaViewer;
@class CVLFile;
@class SenSelection;
@class NSTextView;

@interface CVLDelegate:NSObject
{
    id activeViewer;

    id (activeBrowserController);
    id (outputController);
    NSMutableArray *restoredBrowsers;
    NSMutableDictionary *currentBrowsers; // Key is workArea path => avoid to open two viewers for same workArea path
    ResultsRepository *resultsRepository;
    SenSelection *globalSelection;
    NSConnection	*cvlEditorClientConnection;
#ifdef WIN32
    IBOutlet NSTextView *helpView;
#endif
}

+ (NSString*) resourceDirectory;

- (IBAction) openModule:(id)sender;

- (WorkAreaViewer *)viewerShowingFile:(CVLFile *)aFile;
- (WorkAreaViewer *)newViewerShowingFile:(CVLFile *)aFile;
- (WorkAreaViewer *)viewerWithRootFile:(CVLFile *)aFile; // returns an existing viewer

//- doRepositoryImport: sender;
//- doModuleCvsCheckout: sender;

- (id) viewerForPath:(NSString *)aPath; // Will create viewer only if necessary
- (void) openViewerForPath:(NSString *)aPath;// Calls -viewerForPath:

- (SenSelection *)globalSelection;
@end