/* CVLWaitController.h created by stephane on Thu 21-Oct-1999 */
/*$Id: CVLWaitController.h,v 1.2 2000/05/08 14:04:10 stephane Exp $*/

// Copyright (c) 1997-2000, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <Foundation/NSObject.h>
#import <Foundation/NSDate.h>
#import <AppKit/NSNibDeclarations.h>


@class NSPanel;
@class NSProgressIndicator;
@class NSButton;
@class NSTextField;
@class NSTimer;


#warning (Stephane) We could make it optionally modal
@interface CVLWaitController : NSObject
{
    IBOutlet NSPanel				*waitPanel;
    IBOutlet NSProgressIndicator	*progressIndicator;
    IBOutlet NSButton				*cancelButton;
    IBOutlet NSTextField			*messageTextField;
    BOOL							aborted;
    BOOL							cancellable;
    id								(target);
    SEL								selector;
    id								(userInfo);
    NSTimeInterval					granularity;
    NSTimer							*timer;
    NSString						*message;
    NSTimeInterval					displayThresholdDelay;
}

+ (void) setGranularity:(NSTimeInterval)granularity;
+ (NSTimeInterval) granularity;

+ (void) setDisplayThresholdDelay:(NSTimeInterval)aDelay;
+ (NSTimeInterval) displayThresholdDelay;

+ (CVLWaitController *) waitForConditionTarget:(id)aTarget selector:(SEL)aSelector cancellable:(BOOL)canBeCancelled userInfo:(id)userInfo;
// Will wait until target returns non nil value when performing selector

- (void) setWaitMessage:(NSString *)aMessage;

- (IBAction) cancelWaiting:(id)sender;
- (BOOL) waitCancelled;

@end

extern NSString	*CVLWaitConditionMetNotification;
// UserInfo contains userInfo passed in parameter, for key UserInfo
