/* Comparator.h created by stephane on Wed 29-Sep-1999 */
/*$Id: Comparator.h,v 1.6 2002/06/14 17:21:50 kindov Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <AppKit/NSWindowController.h>


@class CVLFile;
@class NSTextField;
@class NSMatrix;
@class NSPopUpButton;
@class NSButton;
@class NSBox;
@class NSDictionary;
@class NSDateFormatter;


@interface Comparator : NSWindowController
{
    IBOutlet NSTextField	*pathTextField;
    IBOutlet NSMatrix		*leftMatrix;
    IBOutlet NSPopUpButton	*leftRevisionPopup;
    IBOutlet NSPopUpButton	*leftTagPopup;
    IBOutlet NSTextField	*leftDateTextField;
    IBOutlet NSMatrix		*rightMatrix;
    IBOutlet NSPopUpButton	*rightRevisionPopup;
    IBOutlet NSPopUpButton	*rightTagPopup;
    IBOutlet NSTextField	*rightDateTextField;
    IBOutlet NSButton		*ancestorSwitch;
    IBOutlet NSBox			*ancestorBox;
    IBOutlet NSMatrix		*ancestorMatrix;
    IBOutlet NSPopUpButton	*ancestorRevisionPopup;
    IBOutlet NSPopUpButton	*ancestorTagPopup;
    IBOutlet NSTextField	*ancestorDateTextField;
    IBOutlet NSTextField	*mergeTextField;
    IBOutlet NSButton		*mergeChooserButton;
    IBOutlet NSButton		*comparisonButton;
    NSDictionary			*comparisonParameterDictionary;
    CVLFile					*file;
    IBOutlet NSButton		*freeFormSwitch;
    NSDateFormatter			*dateFormatter;
}

+ (Comparator *) sharedComparator;

- (void) comparisonForFile:(CVLFile *)aFile parameters:(NSDictionary *)parameterDictionary;
    /*
        ParameterDictionary: keys are evaluated in this order
        LeftRevision, LeftTag, LeftDate
        RightRevision, RightTag, RightDate
        AncestorRevision, AncestorTag, AncestorDate
        MergeFile
     */

- (IBAction) compareVersions:(id)sender;
- (IBAction) useAncestor:(id)sender;
- (IBAction) choiceChanged:(id)sender;

- (IBAction) toggleFreeFormDate:(id)sender;

@end
