/* CVLFileIconWellCell.h created by stephane on Tue 07-Sep-1999 */
/*$Id: CVLFileIconWellCell.h,v 1.6 2002/07/04 12:20:58 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <AppKit/NSImageCell.h>

#ifdef MACOSX
@class NSControl;
#endif

@interface CVLFileIconWellCell : NSImageCell
{
    id			dataSource;
    NSControl	*_controlView;
    id			_target;
    SEL			_doubleAction;
}

- (void) setDataSource:(id)aDataSource; // DataSource must respond to CVLFileIconWellCellDataSource informal protocol
- (id) dataSource;

- (NSString *) filename; // When there is more than one filename, the first one is returned
- (NSArray *) filenames;

- (NSImage *) image;
    // Overridden to get it dynamically from dataSource

- (void) reloadData;

- (unsigned int) draggingSourceOperationMaskForLocal:(BOOL)flag;
- (NSControl *) controlView;

- (id) target;
- (void) setTarget:(id)anObject;

- (SEL) doubleAction;
- (void) setDoubleAction:(SEL)aSelector;

@end

@interface NSView(CVLFileIconWellCellControlView)

// ControlView MUST implement this method!
- (NSArray *) filenamesForFileIconWellCell:(CVLFileIconWellCell *)aFileIconWellCell;

@end
