/*$Id: CVLInspector.m,v 1.3 2001/03/29 16:52:14 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "CVLInspector.h"

@implementation CVLInspector

+ (CVLInspector *) sharedInstance;
{
    static NSMutableDictionary *sharedInspectors = nil;
    CVLInspector * inspector = nil;
    
    if (sharedInspectors == nil) {
        sharedInspectors = [[NSMutableDictionary dictionary] retain];
    }

    inspector = [sharedInspectors objectForKey:NSStringFromClass(self)];
    if (inspector == nil) {
        inspector = [[[self alloc] init] autorelease];
        [sharedInspectors setObject:inspector forKey:NSStringFromClass(self)];
    }
    return inspector;
}


- init
{
    self = [super init];
    [NSBundle loadNibNamed:NSStringFromClass ([self class]) owner:self];
    if (!view && window) {
        view = [[window contentView] retain];
    }
    return self;
}


- (NSView *) view
{
    return view;
}


- (NSArray *) inspected
{
    return inspected;
}


- (void) setInspected:(NSArray *) anArray
{
    [inspected autorelease];
    inspected = [anArray retain];
    [self update];
}


- (void) update
{
    
}

@end
