/*
	$Id: VLStatusInspector.m,v 1.4 2001/03/30 08:11:25 stephane Exp $
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.


#import "VLStatusInspector.h"

#import <ResultsRepository.h>
#import <Foundation/NSNotification.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSDate.h>
#import <AppKit/AppKit.h>
#import "CVLFile.h"


//-------------------------------------------------------------------------------------

@implementation VLStatusInspector


- (void) setField:vField withObject:(id) anObject
{
  if ([[vField delegate] respondsToSelector: @selector(setTextColor:)])
  {
   if (anObject && [[anObject description] length])
    {
     [[vField delegate] setTextColor: [NSColor controlTextColor]];
      [vField setObjectValue: anObject];
    }
    else
    {
      [[vField delegate] setTextColor: [NSColor darkGrayColor]];
      [vField setStringValue: @""];
    }
  }
#ifdef DEBUG
  else
  {  // sometimes, the delegate is not actually an NSTextField uh -?
    NSLog(@"uh-- field %@ with string %@ has bad delegate", vField, [anObject description]);
  }
#endif
}


- (void) update
{
    // I assume the inspected array contains only one element
    CVLFile *file;
    ResultsRepository* resultRep= [ResultsRepository sharedResultsRepository];
    NSString* element;

    [resultRep startUpdate];
    element=(NSString*) [inspected objectAtIndex: 0];
    file=[CVLFile treeAtPath:element];

    [self setField: statusField withObject: [file statusString]];
    [self setField: versionField withObject: [file revisionInWorkArea]];
    [self setField: repVersionField withObject: [file revisionInRepository]];
    [self setField: stickyTagField withObject: [file stickyTag]];
    [self setField: stickyDateField withObject: [file stickyDate]];
    [self setField: stickyOptionField withObject: [file stickyOptions]];
    [self setField: lastCheckoutedClock withObject: [file dateOfLastCheckout]];
    [self setField: lastModifiedClock withObject: [file modificationDate]];
    [resultRep endUpdate];
}


@end