/* CvsModule.h created by stephane on Wed 08-Sep-1999 */
/*$Id: CvsModule.h,v 1.4 2001/03/30 08:12:08 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <Foundation/NSObject.h>


@class NSArray, NSMutableArray, NSMutableDictionary, NSDictionary, CvsRepository;


@interface CvsModule : NSObject
{
    CvsRepository		*repository; // Not retained, because module is retained (owned) by repository
    NSString			*symbolicName;
    NSArray				*aliases; // -a
    NSString			*directory;
    NSMutableArray		*files;
    NSMutableArray		*additionalModuleNames;
    NSMutableDictionary	*options;
}

+ (NSArray *) parseModuleDescription:(NSString *)moduleDescription forRepository:(CvsRepository *)aRepository generatesModules:(BOOL)generates;
// If generates is YES, will return an array of CvsModules or raise an exception if an error occurred during parsing
// Generated exception contains an entry in userInfo dictionary for key Errors
// If generates is NO, will return an array of error messages if errors occurred during parsing, or nil
// Method tries to parse all lines; if an error occurs in a line, it continues to next line.
// The method can be used to check validity of a file

+ (NSArray *) modulesWithContentsOfFile:(NSString *)filename forRepository:(CvsRepository *)aRepository;
    // Calls [self parseModuleDescription:forRepository:aRepository generatesModules:YES]
	// Can raise.

- (CvsRepository *) repository;
- (void) setRepository:(CvsRepository *)aRepository;

- (NSString *) symbolicName;
- (void) setSymbolicName:(NSString *)aSymbolicName;

- (NSArray *) aliases;
- (void) setAliases:(NSArray *)names;

- (NSString *) directory;
- (void) setDirectory:(NSString *)aDirectory;

- (NSArray *) files;
- (void) setFiles:(NSArray *)names;

- (NSArray *) additionalModuleNames;
- (void) setAdditionalModuleNames:(NSArray *)names;

- (NSString *) outputDirectoryName;
- (void) setOutputDirectoryName:(NSString *)anOutputDirectoryName;

- (NSString *) status;
- (void) setStatus:(NSString *)aStatus;

- (NSDictionary *) options;
- (void) setOptions:(NSDictionary *)someOptions;

- (NSComparisonResult) compareSymbolicName:(CvsModule *)aModule;

@end
