/* NSFileManager.MkDirs.m created by vincent on Tue 04-Nov-1997 */

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "NSFileManager.MkDirs.h"
#import "NSFileManager_CVS.h"
#import <Foundation/NSPathUtilities.h>
#import <Foundation/NSArray.h>

@implementation NSFileManager (MkDirs)

- (BOOL)createAllDirectoriesAtPath:(NSString *)path attributes:(NSDictionary *)attributes
{
  if (path)
  {
    NSArray* pathComponents= [path pathComponents];
    NSString* subPath= @"";
    int i= 0;
    int maxCount= [pathComponents count];
    BOOL allOk= YES;

    if (i < maxCount) // (120) in test !
    { // to avoid first component problem under NT (120)
        subPath= [subPath stringByAppendingPathComponent: [pathComponents objectAtIndex: i++]];
    }
    while (allOk && (i < maxCount))
    {
      subPath= [subPath stringByAppendingPathComponent: [pathComponents objectAtIndex: i++]];
        if(![self cvlDirectoryExistsAtPath:subPath]){
#ifdef CVL_NFS_BUG
            if(![self createDirectoryAtPath: subPath attributes: attributes])
                NSLog(@"??? Unable to create directory at path %@ (attributes: %@) ???", subPath, attributes);
#else
            allOk= [self createDirectoryAtPath: subPath attributes: attributes];
#endif
        }
    }
    return allOk;
  }
  else
    return NO;
}

@end
