/* NSString+CVL.m created by stephane on Wed 31-Oct-2001 */
/*$Id: NSString+CVL.m,v 1.1 2002/06/14 12:48:29 stephane Exp $*/

// Copyright (c) 1997-2000, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "NSString+CVL.h"
#import <Foundation/NSPathUtilities.h>
#import <SenOyster/NSString.SenOysterRegex.h>
#import <Foundation/Foundation.h>
#include <fnmatch.h>


@implementation NSString(CVL)

- (NSString *) cvlFilenameForRevision:(NSString *)aVersion
{
#warning (Stephane) Check for other chars like slash, $, ...
    NSString	*dottedRevision = [aVersion stringByApplyingReplacementOperator: @"s/ /\\./g"];
    NSString	*extension = [self pathExtension];
    
    // Let's not modify the file extension!
    if([extension length])
        return [[[self stringByDeletingPathExtension] stringByAppendingFormat:@"-%@", dottedRevision] stringByAppendingPathExtension:extension];
    else
        return [[self stringByDeletingPathExtension] stringByAppendingFormat:@"-%@", dottedRevision];
}

- (NSString *) cvlFilenameForDate:(NSString *)aDate
{
#warning (Stephane) Check for other chars like slash, $, ...
    NSString	*dottedDate = [aDate stringByApplyingReplacementOperator: @"s/ /\\./g"];
    NSString	*extension = [self pathExtension];

    if([extension length])
        return [[[self stringByDeletingPathExtension] stringByAppendingFormat:@"-%@", dottedDate] stringByAppendingPathExtension:extension];
    else
        return [[self stringByDeletingPathExtension] stringByAppendingFormat:@"-%@", dottedDate];
}

- (BOOL) cvlFilenameMatchesShellPatterns:(NSArray *)patterns
{
    // See fnmatch(3) and sh(1) for more information
    // Meta-characters: * ? [ !
    if(patterns != nil && [patterns count] > 0 && [self length] > 0){
        NSEnumerator	*anEnum = [patterns objectEnumerator];
        NSString		*aPattern;
#ifndef WIN32
        const char		*selfCString = [self fileSystemRepresentation];
#else
        // On Windows, filesystem is case-insensitive (but case-preserving)
        const char		*selfCString = [[self lowercaseString] fileSystemRepresentation];
#endif

        while(aPattern = [anEnum nextObject]){
#ifndef WIN32
            int	result = fnmatch([aPattern fileSystemRepresentation], selfCString, 0);
#else
            int	result = fnmatch([[aPattern lowercaseString] fileSystemRepresentation], selfCString, 0);
#endif

            if(result == 0)
                return YES;
        }
    }
    
    return NO;
}

@end
