/* PreferencesController.m created by ja on Thu 21-Aug-1997 */

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "PreferencesController.h"
#ifdef MACOSX
#import <SenStringArrayBrowserController.h>
#else
#import <SenInterface/SenStringArrayBrowserController.h>
#endif

@implementation PreferencesController
- show: sender
{
    [panel makeKeyAndOrderFront: self];
    //  [pathsController setStringArrayValue:[[NSUserDefaults standardUserDefaults] stringArrayForKey:@"UnixPaths"]];
    [cvsPathTextField setObjectValue:[[NSUserDefaults standardUserDefaults] stringForKey:@"CVSPath"]];
    //  [cvsRootTextField setObjectValue:[[NSUserDefaults standardUserDefaults] stringForKey:@"CVSRoot"]];
    [maxParallelRequestsField setObjectValue:[[NSUserDefaults standardUserDefaults] stringForKey:@"MaxParallelRequestsCount"]];
    [opendiffUnixPathField setObjectValue:[[NSUserDefaults standardUserDefaults] stringForKey:@"OpendiffPath"]];
//    [showRepositoryFilesSwitch setState:[[NSUserDefaults standardUserDefaults] boolForKey:@"ShowRepositoryFiles"]];
    [columnWidthField setIntValue:[[NSUserDefaults standardUserDefaults] integerForKey:@"BrowserColumnWidth"]];
    [columnCountField setIntValue:[[NSUserDefaults standardUserDefaults] integerForKey:@"BrowserColumnCount"]];
    [browserResizeMatrix selectCellAtRow:[[NSUserDefaults standardUserDefaults] integerForKey:@"BrowserResizeBehavior"] column:0];
    [compressionTextField setIntValue:[[NSUserDefaults standardUserDefaults] integerForKey:@"CompressionLevel"]];
    [startupOpenSwitch setState:[[NSUserDefaults standardUserDefaults] boolForKey:@"ShowBrowsers"]];
    [cvsTemplateUseSwitch setState:[[NSUserDefaults standardUserDefaults] boolForKey:@"UseCvsTemplates"]];
    [cvsTemplateFilteringSwitch setState:[[NSUserDefaults standardUserDefaults] boolForKey:@"FilterCvsTemplate"]];
    return self;
}

- (void)set:sender
{
    //  [[NSUserDefaults standardUserDefaults] setObject:[pathsController stringArrayValue] forKey:@"UnixPaths"];
    [[NSUserDefaults standardUserDefaults] setObject:[cvsPathTextField stringValue] forKey:@"CVSPath"];
    //  [[NSUserDefaults standardUserDefaults] setObject:[cvsRootTextField stringValue] forKey:@"CVSRoot"];
    [[NSUserDefaults standardUserDefaults] setObject:[maxParallelRequestsField stringValue] forKey:@"MaxParallelRequestsCount"];
    [[NSUserDefaults standardUserDefaults] setObject:[opendiffUnixPathField stringValue] forKey:@"OpendiffPath"];
//    [[NSUserDefaults standardUserDefaults] setBool:[showRepositoryFilesSwitch state] forKey:@"ShowRepositoryFiles"];
    [[NSUserDefaults standardUserDefaults] setInteger:[columnWidthField intValue] forKey:@"BrowserColumnWidth"];
    [[NSUserDefaults standardUserDefaults] setInteger:[columnCountField intValue] forKey:@"BrowserColumnCount"];
    [[NSUserDefaults standardUserDefaults] setInteger:[browserResizeMatrix selectedRow] forKey:@"BrowserResizeBehavior"];
    [[NSUserDefaults standardUserDefaults] setInteger:[compressionTextField intValue] forKey:@"CompressionLevel"];
    [[NSUserDefaults standardUserDefaults] setBool:[startupOpenSwitch state] forKey:@"ShowBrowsers"];
    [[NSUserDefaults standardUserDefaults] setBool:[cvsTemplateUseSwitch state] forKey:@"UseCvsTemplates"];
    [[NSUserDefaults standardUserDefaults] setBool:[cvsTemplateFilteringSwitch state] forKey:@"FilterCvsTemplate"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"PreferencesChanged" object:self];
}

- hide: sender
{
    if (panel)
        [panel orderOut: self];
    return self;
} // hide:

- (void)awakeWithProperties:(NSDictionary *)someProperties
{
     if ([[someProperties objectForKey:@"autosaveFrame"] isEqual:@"YES"]) {
         // Thank you to Tom Hageman <trh@xs4all.nl> for this feature
         [panel setFrameAutosaveName:[someProperties objectForKey:@"nib"]];
     }
}

@end
