/* CvsLocalRepository.m created by ja on Thu 26-Feb-1998 */
/*$Id: CvsLocalRepository.m,v 1.7 2002/07/01 09:53:42 kindov Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "CvsLocalRepository.h"
#import <SenOyster/SenOyster.h>
#import <SenOyster/NSString.SenOysterRegex.h>
#import <AppKit/NSPanel.h>
#ifdef MACOSX
#import <Foundation/NSArray.h>
#import <Foundation/NSDictionary.h>
#endif

@implementation CvsLocalRepository
+ (NSString *)rootForProperties:(NSDictionary *)properties
{
    NSString *repositoryPath;

    repositoryPath=[properties objectForKey:@"path"];
    if (repositoryPath) {
        if ([repositoryPath rangeOfString:@":"].length==0) { // does it contains ':' ?
            return repositoryPath;
        } else {
            return [@":local:" stringByAppendingString:repositoryPath];
        }
    } else {
        return nil;
    }
}

- initWithMethod:(NSString *)theMethod root:(NSString *)repositoryRoot
{
    if (self=[super initWithMethod:theMethod root:repositoryRoot]) {
        NSString *theRepositoryPath=nil;
        if ([repositoryRoot rangeOfString:@":"].length==1) { // :method: format
            NSArray *matchingResult=[repositoryRoot componentsMatchedByOperator:@"/^:local:(.+)$/"];
            if ([matchingResult count]!=1) {
                NSRunAlertPanel(@"Cvs problem", @"The repository root string you have given is invalid.", nil, nil, nil);
                [self release];
                return nil;
            }
            theRepositoryPath=[matchingResult objectAtIndex:0];
        } else {
            theRepositoryPath=repositoryRoot;
        }
        path=[theRepositoryPath retain];
    }
    return self;
}

- initWithProperties:(NSDictionary *)properties
{
    NSString *theMethod,*theRepositoryPath;

    theMethod=[properties objectForKey:@"method"];
    theRepositoryPath=[properties objectForKey:@"path"];

    if (self=[super initWithMethod:theMethod root:[[self class] rootForProperties:properties]]) {
        path=[theRepositoryPath retain];
    }
    return self;
}

- (BOOL)isLocal
{
    return YES;
}

- (NSDictionary *)properties
{
    return [NSDictionary dictionaryWithObjectsAndKeys:method,@"method",path,@"path",nil];
}

- (NSString *)path
{
    return path;
}

- (void) dealloc
{
    [path release];
    
    [super dealloc];
}

@end
