/* RepositoryDataSource.m created by ja on Mon 15-Dec-1997 */
/*$Id: RepositoryDataSource.m,v 1.3 2001/03/30 08:12:55 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "RepositoryDataSource.h"

@interface CvsRepository (SortedDisplays)
- (NSComparisonResult)compareRoot:(CvsRepository *)theOtherRepository;
@end

@implementation CvsRepository (SortedDisplays)
- (NSComparisonResult)compareRoot:(CvsRepository *)theOtherRepository
{
    return [[self root] compare:[theOtherRepository root]];
}
@end

@implementation RepositoryDataSource
- (void)dealloc
{
    [repositories release];

    [super dealloc];
}

- (int)numberOfRowsInTableView:(NSTableView *)tableView
{
    [repositories release];
    repositories=[[CvsRepository registeredRepositories] sortedArrayUsingSelector:@selector(compareRoot:)];
    [repositories retain];
    
    return [repositories count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row
{
    CvsRepository *repository;
    NSString *columnIdentifier;

    repository=[repositories objectAtIndex:row];
    columnIdentifier=[tableColumn identifier];

    if ([columnIdentifier isEqualToString:@"root"]) {
        return [repository root];
    }
    if ([columnIdentifier isEqualToString:@"password"]) {
        return @"";
    }
    if ([columnIdentifier isEqualToString:@"loggedIn"]) {
        if (![repository needsLogin]) {
            return @"";
        } 
        return ([repository isLoggedIn]?@"YES":@"NO");
    }
    if ([columnIdentifier isEqualToString:@"upToDate"]) {
        return [NSNumber numberWithBool:[repository isUpToDate]];
    }
    return @"";
}

- (void)tableView:(NSTableView *)tableView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn row:(int)row
{
    
}

- (id)objectAtRow:(int)row
{
    return [repositories objectAtIndex:row];
}

- (int)rowOfObject:(id)object
{
    int result;

    result=[repositories indexOfObject:object];
    if (result==NSNotFound)
        result=-1;
    return result;
}
@end
