// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <AppKit/NSWindowController.h>

#ifdef MACOSX
@class NSDictionary;
#endif
@class NSTableView;
@class NSTabView;
@class NSTextView;
@class NSView;
@class NSButton;
@class NSTextField;
@class CvsRepository;
@class NSDateFormatter;


@interface RepositoryViewer : NSWindowController
{
    IBOutlet NSTableView	*tableView;
    IBOutlet NSTabView		*tabView;
    IBOutlet NSTextView		*textView;
    IBOutlet NSTableView	*envTableView;
    IBOutlet NSView			*tabViewItemView;
    IBOutlet NSView			*tabViewEnvItemView;
    IBOutlet NSView			*noRepositoryView;
    IBOutlet NSButton		*removeButton;
    IBOutlet NSButton		*checkoutButton;
    IBOutlet NSButton		*importButton;
    IBOutlet NSButton		*openWorkareaButton;
    IBOutlet NSButton		*saveRepositoryParamsButton;
    IBOutlet NSButton		*validateRepositoryParamsButton;
    IBOutlet NSButton		*revertRepositoryParamsButton;
    IBOutlet NSButton		*addEnvVariableButton;
    IBOutlet NSButton		*removeEnvVariableButton;
    BOOL					initializingTabs;
    NSDateFormatter			*dateFormatter;
    NSButton				*freeFormSwitch;
    NSTextField				*checkoutDateTextField;
}

+ (RepositoryViewer *) sharedRepositoryViewer;

- (IBAction) addRepository:(id)sender;
- (IBAction) removeRepository:(id)sender;
- (IBAction) newRepository:(id)sender;

- (IBAction) repositoryCheckout:(id)sender;
- (IBAction) repositoryImport:(id)sender;
- (IBAction) openRepositoryWorkarea:(id)sender;

- (IBAction) saveRepositoryParams:(id)sender;
- (IBAction) revertRepositoryParams:(id)sender;
- (IBAction) validateRepositoryParams:(id)sender;

- (IBAction) addEnvironmentVariable:(id)sender;
- (IBAction) removeEnvironmentVariable:(id)sender;

- (IBAction) toggleFreeFormDate:(id)sender;

- (void) importIntoRepository:(CvsRepository *)aRepository importInfo:(NSDictionary *)importInfo;
    // importInfo can contains string values for keys module, sourcePath, releaseTag, vendorTag, message

@end
