/* CVLNTLoginRequest.m created by lme on Wed 25-Feb-1998 */
/*$Id: CVLNTLoginRequest.m,v 1.8 2002/07/04 12:24:55 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "CVLNTLoginRequest.h"
#ifdef MACOSX
#import <CvsLoginRequest.h>
#else
#import <Requests/CvsLoginRequest.h>
#endif
#import <SenOyster/NSString.SenOysterRegex.h>
#ifdef MACOSX
#import <CvsRepository.h>
#else
#import <Repositories/CvsRepository.h>
#endif
#import <AppKit/NSPanel.h>
#import <stdlib.h>
#ifdef MACOSX
#import <Foundation/NSPathUtilities.h>
#endif

@implementation CVLNTLoginRequest

+ (CVLNTLoginRequest *) CVLNTLoginRequestForRepository:(CvsRepository *)aRepository
{
    CVLNTLoginRequest* request= [self requestWithCmd: 12 title:@"login (NT)" path:nil files:nil];

    [request setRepository: aRepository];
    return request;
}

#if 0
- (NSString*) passwordByReadingCvsPass
{
    NSString* password= nil;
    NSString* cvspassContent= [[NSString alloc] initWithContentsOfFile: [[self homeDirectory] stringByAppendingPathComponent:@".cvspass"]];
    NSArray* cvspassLines= [cvspassContent componentsSeparatedByOperator: CvsRequestNewLinePattern];
    int i= [cvspassLines count];
    BOOL found= NO;

    while ((!found) && (i--))
    {
        NSString* currentLine= [cvspassLines objectAtIndex: i];

        if ([currentLine hasPrefix: [repository root]])
        {
            NSArray* parts= [currentLine componentsSeparatedByString:@" "];

            found= YES;
            if ([parts count])
            {
                password= [parts objectAtIndex: 1];
            }
        }
    }
    return password;
}
#endif

- (void) start
{
    NSString* systemParamString= [NSString stringWithFormat: @"cvs -d %@ login", [repository root]];
    int retValue= 0;
    BOOL retry= YES;

    [super start];

    retValue= system([systemParamString cString]);

#ifdef DEBUG
    NSLog(@"system returns %d", retValue);
#endif

    while ((retry) && (retValue != 0))
    {
        retry= (BOOL) (NSRunAlertPanel(@"Wrong Password", @"Do you want to retry ?", @"Yes", @"No", nil)==NSAlertDefaultReturn);
        if (retry)
        {
            retValue= system([systemParamString cString]);
        }
    }
    if (retValue != 0)
    {   // failure
        success= NO;
        internalState=STATE_LOGIN_PANEL;
        [self setState:STATE_READY];
    }
    // else success (set by default)

    [self end];  // stop myself now
}

#ifdef JA_PATCH
- (void) endWithSuccess
{
    [repository setIsLoggedIn:YES];
}

- (void)endWithFailure
{
    [repository setIsLoggedIn:NO];
}

-(NSString *)summary
{
    return [[repository root] lastPathComponent];
}
#else
- (void) end
{
    if (internalState!=STATE_NOT_STARTED) {
        [repository setIsLoggedIn:success];
    }
    [super endWithoutInvalidation];
}


-(NSString *)summary
{
    return [[repository root] lastPathComponent];
}


- (BOOL) canContinue
{
    return [self precedingRequestsEnded];
}
#endif

- (BOOL) canRunAgainstRequest:(Request *)runningRequest
{
    return !([runningRequest isKindOfClass:[self class]]);
}

- (NSString *)shortDescription
{
    return [NSString stringWithFormat: @"%@ in %@\n", [self cmdTitle], [repository root]];
}

@end
