/* CvsCommitRequest.m created by vincent on Mon 24-Nov-1997 */
/*$Id: CvsCommitRequest.m,v 1.4 2001/04/17 15:12:38 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "CvsCommitRequest.h"
#import "../NSArray.SenCategorize.h"

@implementation CvsCommitRequest

+ (id) cvsCommitRequestForFiles: (NSArray*) someFiles inPath:(NSString *)aPath message: (NSString*) mesgString
{
    NSArray *checkedFiles=nil;
    NSDictionary* pathDict;
    NSString* commonPath;
    CvsCommitRequest *newRequest;

    if (someFiles) {
        pathDict=[[self class] canonicalizePath: aPath andFiles: someFiles];
        commonPath= [[pathDict allKeys] objectAtIndex: 0];
        checkedFiles= [pathDict objectForKey: commonPath];
    } else {
        commonPath=aPath;
    }

    newRequest=[self requestWithCmd: 7 title:@"commit" path: commonPath files: checkedFiles];

    [newRequest setMessage: mesgString];
  return newRequest;
}

- (void)dealloc
{
  [message release];
  [super dealloc];
}

- (void) setMessage: (NSString*) aString
{
  if (aString != message)
  {
    [message release];
    message= [aString retain];
  }
}

- (void) setRevision:(NSString*)aString
{
    if(aString != revision){
        [revision release];
        revision = [aString retain];
    }
}


- (NSArray *)cvsCommandOptions
{
    if([[NSUserDefaults standardUserDefaults] boolForKey:@"UseCvsTemplates"]){
        if(revision)
            return [NSArray arrayWithObjects:@"-r", revision, nil];
        else
            return [NSArray array];
    }
    else{
        if(revision)
            return [NSArray arrayWithObjects:@"-r", revision, @"-m", nil];
        else
            return [NSArray arrayWithObject:@"-m"];
    }
}


- (NSArray *)cvsOptions
{
    if([[NSUserDefaults standardUserDefaults] boolForKey:@"UseCvsTemplates"]){
#ifdef MACOSX
        return [[super cvsOptions] arrayByAddingObjectsFromArray:[NSArray arrayWithObjects:@"-e", [[NSBundle mainBundle] pathForAuxiliaryExecutable:@"cvlEditor"], nil]];
#else
#ifdef WIN32
        return [[super cvsOptions] arrayByAddingObjectsFromArray:[NSArray arrayWithObjects:@"-e", [[NSBundle mainBundle] pathForResource:@"cvlEditor" ofType:@"exe"], nil]];
#else
        return [[super cvsOptions] arrayByAddingObjectsFromArray:[NSArray arrayWithObjects:@"-e", [[NSBundle mainBundle] pathForResource:@"cvlEditor" ofType:@""], nil]];
#endif
#endif
    }
    else
        return [super cvsOptions];
}

- (NSArray *)cvsCommandArguments
{
    if([[NSUserDefaults standardUserDefaults] boolForKey:@"UseCvsTemplates"])
        return [self files];
    else{
        NSMutableArray* arguments= [NSMutableArray arrayWithCapacity: 2];

        [arguments addObject: message];
        [arguments addObjectsFromArray: [self files]];
        return arguments;
    }
}

- (NSString *)cvsWorkingDirectory
{
    return [self path];
}

@end
