/* CvsImportRequest.m created by vincent on Wed 26-Nov-1997 */
/*$Id: CvsImportRequest.m,v 1.4 2002/07/04 12:30:03 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "CvsImportRequest.h"
#import <Foundation/NSArray.h>
#import <Foundation/NSString.h>

@implementation CvsImportRequest

+ (id) cvsImportRequestForModule: (NSString*) aModule
                    inRepository: (CvsRepository *)aRepository
                      importPath: (NSString *)aPath
                      releaseTag: (NSString*) rTag
                       vendorTag: (NSString*) vTag
                         message: (NSString*) mesgString
{
    CvsImportRequest* newRequest= [self requestWithCmd: 9 title:@"import" path:aPath files: nil];

    [newRequest setModule: aModule];
    [newRequest setReleaseTag: rTag];
    [newRequest setVendorTag: vTag];
    [newRequest setMessage: mesgString];
    [newRequest setRepository:aRepository];

    return newRequest;
}


- (void) dealloc
{
    [module release];
    [releaseTag release];
    [vendorTag release];
    [message release];
    [super dealloc];
}


- (void) setModule: (NSString*) aString
{
    if (aString != module)
    {
        [module release];
        module= [aString retain];
    }
}


- (void) setReleaseTag: (NSString*) aString
{
    if (aString != releaseTag)
    {
        [releaseTag release];
        releaseTag= [aString retain];
    }
}

- (void) setVendorTag: (NSString*) aString
{
    if (aString != vendorTag)
    {
        [vendorTag release];
        vendorTag= [aString retain];
    }
}

- (void) setMessage: (NSString*) aString
{
    if (aString != message)
    {
        [message release];
        message= [aString retain];
    }
}

- (NSArray *)cvsCommandOptions
{
  return [NSArray arrayWithObject:@"-m"];
}


- (NSArray *)cvsCommandArguments
{
    NSArray* arguments= [NSMutableArray arrayWithObjects: message, module, vendorTag, releaseTag, nil];

    return arguments;
}

- (NSString *)cvsWorkingDirectory
{
    return [self path];
}

#ifdef JA_PATCH
- (void)endWithSuccess;
{
}

- (void)endWithFailure;
{
}
#else
- (void) end
{
    [super endWithoutInvalidation];
}
#endif
@end
