/*
	$Id: CvsRequest.h,v 1.8 2002/07/04 12:30:03 stephane Exp $
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#ifdef MACOSX
#import <TaskRequest.h>
#else
#import <Requests/TaskRequest.h>
#endif


@class NSArray, NSDictionary, CvsRepository;


#define CVS_STATUS_CMD_TAG          0
#define CVS_LOG_CMD_TAG             1
#define CVS_UPDATE_CMD_TAG          2
#define CVS_REMOVE_CMD_TAG          3
#define CVS_DIFF_CMD_TAG            4
#define CVS_OBJCOMMENT_CMD_TAG      5
#define CVS_NOKEYWDEXP_CMD_TAG      6
#define CVS_COMMIT_CMD_TAG          7  // first of cmds with argument
#define CVS_TAG_CMD_TAG             8
#define CVS_IMPORT_CMD_TAG          9  // queue contains dir where to 'cd'
#define CVS_CHECKOUT_CMD_TAG       10
#define CVS_ADD_CMD_TAG            11  // special cmd
#define CVS_UNIX_CMD_TAG           12
#define CVS_GET_TAGS_CMD_TAG       13
#define CVS_VERSION_TAG            14
#define CVS_INIT_CMD_TAG           15
#define CVS_QUICK_STATUS_CMD_TAG   16
#define CVS_RELEASE_CMD_TAG        17
#define CVS_CMD_COUNT              18  // (120) UNIX added as hack

#define STATE_CVS_TRY_LOGIN 3
#define STATE_CVS_RETRY_AFTER_LOGIN 2


extern NSString* CvsRequestNewLinePattern;
extern NSString* CvsRequestLineOfEqualsOrMinusPattern;


@interface CvsRequest : TaskRequest
{
    int cmd;
    NSString *path;
    NSArray *files;
    CvsRepository *repository;
    BOOL needsLogin;
#ifdef JA_PATCH
    BOOL noLogin;
    CvsRequest *repositoryRequest;
#endif
}

+ (NSDictionary*) canonicalizePath: (NSString*) aPath andFiles: (NSArray*) someFiles;
    // remove any subpath from files and return common dir as key and files as value (only one common path is allowed)

+ requestWithCmd:(int)aCmd title:(NSString *)cmdString path:(NSString *)thePath files:(NSArray *)someFiles;
- initWithCmd:(int)aCmd title:(NSString *)cmdString path:(NSString *)thePath files:(NSArray *)someFiles;

- (void)setPath:(NSString *)value;
- (NSString *)path;
- (void)setFiles:(NSArray *)value;
- (NSArray *)files;

- (CvsRepository *)repository;
- (void)setRepository:(CvsRepository *)aRepository;

- (int)cmd;

- (NSArray *)cvsOptions;
- (NSString *)cvsCommand;
- (NSArray *)cvsCommandOptions;

- (void)updateFileStatuses;
#ifndef JA_PATCH
- (void)endWithoutInvalidation;
#endif

- (unsigned) compressionLevel; // -z option; currently, default implementation returns CompressionLevel userDefault (0-9, 0 = no compression, 9 = max compression)

@end
