/* SelectorRequest.m created by stephane on Mon 31-Jan-2000 */
/*$Id: SelectorRequest.m,v 1.5 2002/07/04 12:33:50 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "SelectorRequest.h"
#import <Foundation/Foundation.h>


@implementation SelectorRequest

+ (id) requestWithTarget:(id)aTarget selector:(SEL)aSelector argument:(id)anArgument
{
    SelectorRequest	*aRequest = [[self alloc] initWithTitle:NSStringFromSelector(aSelector)];

    aRequest->selector = aSelector;
    aRequest->target = [aTarget retain];
    aRequest->argument = [anArgument retain];

    return aRequest;
}

- (void) dealloc
{
    [target release];
    [argument release];
    
    [super dealloc];
}

#ifndef JA_PATCH
- (void) start
{
    [super start];

    if(!selector || !target || ![target respondsToSelector:selector]){
        [self cancel];
        return;
    }
    
    NS_DURING
        [target performSelector:selector withObject:argument];
        success = YES;
	NS_HANDLER
        success = NO;
	NS_ENDHANDLER

    if(success)
        [self end];
}
#endif

- (BOOL) canBeCancelled
{
    return NO;
}

@end
