/* TaskRequest.h created by ja on Mon 24-Nov-1997 */
/*$Id: TaskRequest.h,v 1.4 2002/07/04 12:33:50 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#ifdef MACOSX
#import <Request.h>
#else
#import <Requests/Request.h>
#endif


@class NSTask, NSPipe, NSFileHandle, NSMutableString;


#define STATE_TASK_RUN_TASK 1

@interface TaskRequest : Request
{
    BOOL isQuiet;
    NSTask *task;
    NSPipe *pipe;
    NSPipe *errorPipe;
    NSFileHandle *readHandle;
    NSFileHandle *errorReadHandle;
    int taskEndConditionsCount;
    BOOL parseByLine;
    NSMutableString* lastReceivedString;
    NSMutableString* lastReceivedErrorString;
#ifdef JA_PATCH
    BOOL taskAuthorized;
#endif
}

//+ requestWithTitle:(NSString *)cmdString path:(NSString *)thePath args:(NSArray *)theArgs;
//- initWithTitle:(NSString *)cmdString path:(NSString *)thePath args:(NSArray *)theArgs;

- (void) setTask: (NSTask*) aTask;

- (BOOL)startTask;
- (BOOL)setUpTask;
// query methods
- (BOOL)isQuiet;
- (void)setIsQuiet:(BOOL)value;
#ifdef JA_PATCH
- (id)taskTerminated:(NSNotification *)notification;
#endif

- (id)outputFile; //returns a NSFileHandle or a NSPipe, Do not use, subclass only
- (id)errorFile;

- (void)parseOutput:(NSString *)data;
- (void)parseError:(NSString *)data;

#ifdef JA_PATCH
- (void)closeReadHandle;
- (void)closeErrorReadHandle;
#else
- (void)taskEnded;
#endif
- (void)taskCleanUp;
@end
