/*
	$Id: ResultsRepository.h,v 1.7 2002/06/17 16:26:13 kindov Exp $
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <Foundation/Foundation.h>
#import <CVLFile.h>

@class NSMutableDictionary;
@class NSDictionary;
@class NSMutableArray;
@class NSArray;
@class CvsRepository;
@class CVLFile;

@interface ResultsRepository : NSObject
{
    NSMutableSet *changedFiles;
    NSMutableSet *oldChangedFiles;

    int             updateCount;
    NSMutableArray *statusRequests;
    NSMutableArray *statusQueue;
    NSMutableArray *quickStatusQueue;
    NSMutableArray *logRequests;
    NSMutableArray *logQueue;
    NSMutableArray *tagsRequests;
    NSMutableArray *tagsQueue;
    NSMutableSet	*quickStatusTargetPaths;
    BOOL performStatusPending;
    BOOL performQuickStatusPending;
    BOOL performLogPending;
    BOOL performTagsPending;

    //        BOOL showRepositoryFiles;
}

+ (ResultsRepository *)sharedResultsRepository;

- (void)startUpdate;
- (void)endUpdate;
- (BOOL)hasChanged;
- (NSSet *) changedFiles;

//- (void)updateDir:(NSString *)fullPath;
//- (NSObject *)resultForPath:(NSString *)path andKey:(NSString *)key;
//- (void)setResults:results forPath:(NSString *)path;

- (void)getStatusForFile:(CVLFile *)file;
- (void) getQuickStatusForFile:(CVLFile *)file;
- (void)getLogForFile:(CVLFile *)file;
- (void)getDifferencesForFile:(CVLFile *)file context:(unsigned)context outputFormat:(CVLDiffOutputFormat)outputFormat;
- (void)getTagsForFile:(CVLFile *)file;

- (void)fileDidChange:(CVLFile *)file;
@end
