/*$Id: RetrievePanelController.h,v 1.5 2002/06/14 12:47:06 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <AppKit/AppKit.h>


@class CVLFile;

#define CVL_RETRIEVE_CANCELED 0
#define CVL_RETRIEVE_REPLACE 1
#define CVL_RETRIEVE_SAVE_AS 2
#define CVL_RETRIEVE_OPEN 3

@interface RetrievePanelController : NSObject
{
    id panel;
    id dateCell;
    id openButton;
    id saveAsButton;
    IBOutlet NSButton	*stickySwitch;
    IBOutlet NSButton	*freeFormSwitch;
    IBOutlet NSComboBox	*revisionCombo;
    NSDateFormatter		*dateFormatter;
    NSArray				*tags;
    CVLFile				*selectedFile;

    NSString * destPath;
    int result;
}
+ new;
- show: sender;
- hide: sender;
- ok: sender;
- cancel: sender;
- (IBAction) toggleFreeFormDate:(id)sender;

- (void) saveAs: sender;

- (int) runModalForFiles: (NSArray*) files inPath:(NSString *)path;
//- (int) runModal;

- (NSString *)dateString;
- (NSString *)revision;
- (BOOL) removesStickyAttributes;

- (NSString*) buildDestinationPath;
- (NSString *)destinationPath;

@end
