/* NSString+Lines.m created by stephane on Mon 05-Feb-2001 */
/*$Id: NSString+Lines.m,v 1.2 2001/04/28 13:15:32 stephane Exp $*/

// Copyright (c) 1997-2000, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "NSString+Lines.h"
#import <Foundation/NSArray.h>

@implementation NSString(Lines)

// Use -lines instead of -componentsSeparatedByString: to get lines
// from a string.
// Thanks to Moritz Thomas <motho@gmx.net> for this suggestion

- (NSArray *) lines
{
    NSRange			range = NSMakeRange(0, 1);
    unsigned		length = [self length], content, line;
    NSMutableArray	*anArray = [NSMutableArray array];

    while(range.location < length){
        [self getLineStart:&range.location end:&line contentsEnd:&content forRange:range];
        range.length = content - range.location;
        [anArray addObject:[self substringWithRange:range]];

        range.location = line + 1;
        range.length = 1;
    }

    return anArray;
}

@end
