/* NSString+SenPathComparison.m created by stephanec on Mon 13-Dec-1999 */
/*$Id: NSString+SenPathComparison.m,v 1.1 2000/02/10 12:42:33 stephane Exp $*/
/* Copyright (c) 1997, Sen:te Ltd.  All rights reserved. */

#import "NSString+SenPathComparison.h"

@implementation NSString(SenPathComparison)

- (BOOL) senIsParentOf:(NSString *)aPath immediately:(BOOL)isImmediateParent
{
    NSArray			*pathComponents = [self pathComponents];
    NSArray			*otherPathComponents = [aPath pathComponents];
    int				count = [pathComponents count], otherCount = [otherPathComponents count];
    NSEnumerator	*pathComponentEnum;
    NSEnumerator	*otherPathComponentEnum;
    NSString		*aPathComponent;

    if(count >= otherCount)
        return NO;

    if(isImmediateParent && count != otherCount - 1)
        return NO;

    pathComponentEnum = [pathComponents objectEnumerator];
    otherPathComponentEnum = [otherPathComponents objectEnumerator];

    while(aPathComponent = [pathComponentEnum nextObject])
        if(![aPathComponent isEqualToString:[otherPathComponentEnum nextObject]])
            return NO;

    return YES;
}

@end
