/* NSString_RevisionComparison.m created by vincent on Fri 22-May-1998 */
/*$Id: NSString_RevisionComparison.m,v 1.3 2001/03/30 08:16:33 stephane Exp $*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "NSString_RevisionComparison.h"
#import <Foundation/Foundation.h>

@implementation NSString (RevisionComparison)

int keySort(id dict1, id dict2, void *sortKey)
{
  NSString* v1 = [dict1 objectForKey: sortKey];
  NSString* v2 = [dict2 objectForKey: sortKey];

  if ([(NSString*)sortKey isEqualToString: @"revision"])
  {
    return [v2 compareRevision: v1];
  }
  else return [v2 compare: v1]; // reverse order
}


- (NSComparisonResult) compareRevision: (NSString*) aString
{
  NSEnumerator* myEnum= [[self componentsSeparatedByString: @"."] objectEnumerator];
  NSEnumerator* anEnum= [[aString componentsSeparatedByString: @"."] objectEnumerator];
  NSString* mySub= [myEnum nextObject];
  NSString* aSub= [anEnum nextObject];
  NSComparisonResult lastCompare= NSOrderedSame;

  while ((lastCompare == NSOrderedSame) && mySub && aSub)
  {
    int myValue= [mySub intValue];
    int aValue= [aSub intValue];

    lastCompare= (myValue == aValue ? NSOrderedSame : (myValue < aValue ? NSOrderedAscending : NSOrderedDescending));
    mySub= [myEnum nextObject];
    aSub= [anEnum nextObject];
  }
  if (lastCompare == NSOrderedSame)
  {
    if ((!mySub) && (!aSub))
    {
      return lastCompare;
    }
    else if (!mySub)
    {
      return NSOrderedAscending;
    }
    else return NSOrderedDescending;
  }
  return lastCompare;
}

@end
