/* SenFormPanelController.m created by ja on Wed 25-Feb-1998 */
/* $Id: SenFormPanelController.m,v 1.15 2001/04/17 16:04:13 stephane Exp $ */

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.


#import "SenFormPanelController.h"


@implementation SenFormPanelController
- (int)showAndRunModal
{
    int res= -1;

    [[NSNotificationCenter defaultCenter] postNotificationName:@"PanelWillRun" object:self];
    [panel makeKeyAndOrderFront:self];
    if([panel initialFirstResponder])
        [panel makeFirstResponder:[panel initialFirstResponder]];
    res= [NSApp runModalForWindow: panel];
    [panel orderOut: self];

    return res;
}

- (void)cancel:sender
{
    [NSApp stopModalWithCode:NSCancelButton];
} // cancel:


- (void)ok:sender
{
    [formController takeObjectValuesFromAllControls];
    [NSApp stopModalWithCode:NSOKButton];
} // ok:

- (void)awakeWithProperties:(NSDictionary *)someProperties
{
    NSDictionary *defaultValues;
    if (defaultValues=[someProperties objectForKey:@"defaultValues"]) {
        [self setDictionaryValue:defaultValues];
    }
     if ([[someProperties objectForKey:@"autosaveFrame"] isEqual:@"YES"]) {
         // Thank you to Tom Hageman <trh@xs4all.nl> for this feature
         [panel setFrameAutosaveName:[someProperties objectForKey:@"nib"]];
     }
}

- (NSWindow *)panel
{
    return panel;
}

- (SenFormController *)formController
{
    return formController;
}

- (NSDictionary *)dictionaryValue
{
    return [formController dictionaryValue];
}

- (id)objectValueForKey:(NSString *)aKey
{
    return [formController objectValueForKey:aKey];
}

- (void)setDictionaryValue:(NSDictionary *)newValues
{
    NSString *panelTitle;
    [formController setDictionaryValue:newValues];
    if (panelTitle=[newValues objectForKey:@"PanelTitle"]) {
        [panel setTitle:panelTitle];
    }
}

- (void)setObjectValue:(id)newValue forKey:(NSString *)aKey
{
    if ([aKey isEqual:@"PanelTitle"]) {
        [panel setTitle:newValue];
    }
    [formController setObjectValue:newValue forKey:aKey];
}

- (void)addValuesFromDictionary:(NSDictionary *)newValues
{
    NSString *panelTitle;
    [formController addValuesFromDictionary:newValues];
    if (panelTitle=[newValues objectForKey:@"PanelTitle"]) {
        [panel setTitle:panelTitle];
    }
}

- (id)initWithCoder:(NSCoder *)decoder
{
    int		version;

    self = [self init];

    version = [decoder versionForClassName:@"SenFormController"];
    /*
    switch (version) {
    case 0:
        break;
    default:
        break;
    } */
    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
    //[super encodeWithCoder:coder];

    // Version == 1
}

@end
