/*
	$id$
*/

// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <Foundation/Foundation.h>
#import <AppKit/NSNibDeclarations.h>


@class CVLFile;

@interface WorkAreaViewer:NSObject
{
	id window;
	id viewHolder;
    id filterProvider;
    id filterButtonsMatrix;
	
	id	(browserViewer);
	id	(listViewer);
	id	(currentViewer);

    id processesButton;
    CVLFile * rootFile;
	BOOL windowIsMiniaturized;
    id filterPopup;
}

+ (WorkAreaViewer*) viewerForPath: (NSString*) aPath;
+ (WorkAreaViewer*) viewerForFile: (CVLFile *) aFile;

- initForFile: (CVLFile *) aFile;

- (void)showWindowWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)stateDictionary;
- (void)viewerFrameSizeChanged:(id)sender;

- (void) filterPreselectionPopped:(id)sender;

- (void) show: sender;
- (void) setBrowserView: sender;
- (void) setListView: sender;
- (id) viewer;

- (NSArray *)relativeSelectedPaths; // Paths relatively to root path
- (NSArray *)selectedPaths;

- (void)selectFiles:(NSSet *)someFiles;

- (NSString *)rootPath;
- (CVLFile *)rootFile;

- (void) retrieveSelectedFilesVersion:sender;
- (void) retrieveWorkAreaVersion:sender;
- (void) updateSelectedFiles:sender;
- (void) updateWorkArea:sender;

- (void) commitSelectedFiles:sender;
- (void) commitWorkArea:sender;
- (IBAction) closeWorkArea:(id)sender;

- (void) tagSelectedFiles:sender;
- (void) tagWorkArea:sender;

- (void) diffSelectedFiles:sender;
- (void) addSelectedFiles:sender;
- (void) addSelectedFilesAsBinary:sender;
- (void) removeSelectedFiles:sender;

- (void) refreshSelectedFiles:sender;

//- (IBAction) renameSelectedFile:(id)sender;
- (IBAction) releaseWorkArea:(id)sender;

//- (void) doRetrieveFile:(NSString *)filePath inPath:(NSString *)path withRevision:(NSString *)revision date:(NSString *)dateString outputFile:(NSString *)fullPath;

@end
