
// Copyright (c) 1997-2001, Sen:te Ltd.  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import <Foundation/Foundation.h>
#import <CVLEditorClient.h>


int main(int argc, const char *argv[])
{
    NSAutoreleasePool					*pool = [[NSAutoreleasePool alloc] init];
    NSArray								*args = [[NSProcessInfo processInfo] arguments];
    NSDistantObject <CVLEditorClient>	*proxy;
    int									exitCode = 0;
    
    NSCAssert([args count] == 2, @"cvlEditor must have exactly only ONE arg, a filename."); // 2 = executable + 1 arg
    
	proxy = [NSConnection rootProxyForConnectionWithRegisteredName:CVLEditorClientConnectionName host:nil]; // Search only on localhost
    if(!proxy){
        NSLog(@"cvlEditor couldn't get rootProxy for local connection %@", CVLEditorClientConnectionName);
        exitCode = 1;
        goto myEnd;
    }
    [proxy setProtocolForProxy:@protocol(CVLEditorClient)];
    if(![proxy commitWithTemplateInFile:[args lastObject]])
        exitCode = -1;

myEnd:
    [pool release];
    exit(exitCode);
    return exitCode;
}
