/*$Id: NSInvocation_SenTesting.m,v 1.6 2001/11/22 13:13:49 phink Exp $*/

// Copyright (c) 1997-2001, Sen:te (Sente SA).  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "NSInvocation_SenTesting.h"
#import <SenFoundation/SenFoundation.h>

@implementation NSInvocation (SenTesting)

NSString *DefaultTestMethodPrefix = @"test";
static NSString *testMethodPrefix = nil;


+ (NSString *) testMethodPrefix
{
    return (testMethodPrefix != nil) ? testMethodPrefix : DefaultTestMethodPrefix;
}


+ (void) setTestMethodPrefix:(NSString *) aPrefix
{
    ASSIGN(testMethodPrefix,aPrefix);
}


- (NSString *) testMethodPrefix
{
    return [[self class] testMethodPrefix];
}


- (BOOL) isReturningVoid
{
    return strcmp ([[self methodSignature] methodReturnType], "v") == 0;
}


- (BOOL) hasTestPrefix
{
    return [NSStringFromSelector([self selector]) hasPrefix:[self testMethodPrefix]];
}


- (unsigned) numberOfParameters
{
    return [[self methodSignature] numberOfArguments] - 2;
}


- (BOOL) hasTestCaseSignature
{
    return ([self numberOfParameters] == 0) && [self isReturningVoid] && [self hasTestPrefix];
}
@end
